; Tray_AutoDial.asm Establish dial up connection or hangup using a tray icon 
;                   Plays sound upon connection
;                   Based on code from William F. Cravener and Gangleri 
;
;
    .586                      ; create 32 bit code
    .model flat,stdcall       ; 32 bit memory model
    option casemap :none      ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\winmm.inc
    include \masm32\include\rasapi32.inc
    
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\winmm.lib
    includelib \masm32\lib\rasapi32.lib

    WM_SHELLNOTIFY equ WM_APP+5

    IDI_TRAY    equ 0
    IDM_EXIT    equ 100
    IDM_Dial    equ 200 
    IDM_Hangup  equ 250 
    IDH_HOTKEY1 equ 101
    
    WinMain      PROTO :DWORD,:DWORD,:DWORD,:DWORD
    WndProc      PROTO :DWORD,:DWORD,:DWORD,:DWORD

RASENTRYNAME5A STRUCT
        dwSize          dd ?
        szEntryName     db 260 dup(?)
        dwFlags         dd ?
        szPhonebookPath db 264 dup(?)
    RASENTRYNAME5A ENDS

    RASENTRYNAME5 EQU <RASENTRYNAME5A>

    RASDIALPARAMS4A STRUCT
        dwSize           dd ?
        szEntryName      db 101h dup(?)
        szPhoneNumber    db 81h dup(?)
        szCallbackNumber db 81h dup(?)
        szUserName       db 101h dup(?)
        szPassword       db 101h dup(?)
        szDomain         db 13h dup(?)
        dwSubEntry       dd ?
        dwCallbackId     dd ?
    RASDIALPARAMS4A ENDS

    RASDIALPARAMS4 EQU <RASDIALPARAMS4A>

.data

    hInstance     dd 0
    hWnd          dd 0
    hIcon         dd 0
    hPopupMenu    dd 0 

    szClassName   db "AutoDial",0
    szDisplayName db "Dialing Out",0
                     
    szExitString  db  "Exit program",0
    szDial_Out    db  "Dial in to Internet.",0
    szHangup      db  "Disconnect from the internet.",0 
    szApp         db  "AutoDial",0
    Sound         db  "C:\WINDOWS\Media\tada.wav",0

    pt            POINT <>
    note          NOTIFYICONDATA <>

.data?

l_RASCONN RASCONN 0FFh dup ({})
l_Buffer_Size dd   ?
l_Conn_Count  dd   ?

.code

WaterMark   db "SiegeWorks"
%Date       db " &@Date " ; Compile date

start:
    invoke GetModuleHandle,0
    mov hInstance,eax
    invoke WinMain,hInstance,0,0,0
    invoke ExitProcess,eax

WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

; Standard window creation stuff

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG

    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov eax,hInst
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,OFFSET szClassName
    invoke LoadImage,hInstance,500,IMAGE_ICON,0,0,LR_DEFAULTSIZE
    mov hIcon,eax
    mov wc.hIcon,eax
    invoke LoadCursor,0,IDC_ARROW
    mov wc.hCursor,eax
    mov wc.hIconSm,0

    invoke RegisterClassEx,ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          0,0,0,0,
                          0,0,
                          hInstance,0
    mov hWnd,eax

    StartLoop:
      invoke GetMessage,ADDR msg,0,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage,ADDR msg
      invoke DispatchMessage,ADDR msg
      jmp StartLoop
    ExitLoop:
      
    mov eax,msg.wParam 
    ret

WinMain endp

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

LOCAL lpRasEntryName     :DWORD
 LOCAL dwCb              :DWORD
 LOCAL dwEntries         :DWORD
 LOCAL rp                :RASDIALPARAMS4
 LOCAL fPass             :BOOL
 LOCAL hConn             :DWORD

        .if uMsg == WM_CREATE
            
            ; We will need a pop up menu 
            
            invoke CreatePopupMenu 

            mov    hPopupMenu,eax 

            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_Dial,ADDR szDial_Out
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_Hangup,ADDR szHangup
            invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,ADDR szExitString
                                    
            ; Send WM_SIZE which will place our app icon in system tray.
            
            invoke SendMessage,hWin,WM_SIZE,SIZE_MINIMIZED,0

    .elseif uMsg == WM_COMMAND
            
            ; Handle the pop up menu options to Dial In or Exit the program.
            
            .if lParam == 0 
                mov eax,wParam 
                .if eax == IDM_EXIT 
                    invoke Shell_NotifyIcon,NIM_DELETE,ADDR note 
                    invoke SendMessage,hWin,WM_DESTROY,0,0

                .elseif eax == IDM_Dial

; Let's dial in for dollars :-)
                
mov dwCb, sizeof RASENTRYNAME5
mov lpRasEntryName, 0

AllocateRasEntryNameLoop1:

      cmp lpRasEntryName, 0
      je  AllocateRasEntryName1
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

AllocateRasEntryName1:
      invoke GetProcessHeap
      invoke HeapAlloc, eax, 0, dwCb
      cmp    eax, 0
      je     RetFail1
     
      mov lpRasEntryName, eax
      invoke RtlZeroMemory, lpRasEntryName, dwCb
      mov ebx, sizeof RASENTRYNAME5
      mov eax, lpRasEntryName
      mov (RASENTRYNAME5 PTR [eax]).dwSize, ebx

      invoke RasEnumEntries, NULL, NULL, lpRasEntryName, ADDR dwCb, ADDR dwEntries
      cmp eax, 278h
      je AllocateRasEntryNameLoop1

      cmp eax, 0
      jne RetFail1

      mov dwCb, sizeof RASDIALPARAMS4

      invoke RtlZeroMemory, ADDR rp, dwCb     
      mov eax, dwCb
      mov rp.dwSize, eax

      mov eax, lpRasEntryName

 invoke lstrcpy, ADDR rp.szEntryName, ADDR (RASENTRYNAME5 PTR [eax]).szEntryName

 invoke RasGetEntryDialParams, NULL, ADDR rp, ADDR fPass
      cmp eax, 0
      jne RetFail1
      mov hConn, 0

      invoke RasDial, NULL, NULL, ADDR rp, 0, NULL, ADDR hConn
      cmp eax, 0
      jne RetFail1
      invoke PlaySound,ADDR Sound,NULL,SND_SYNC

RetFail1:

      cmp lpRasEntryName, 0
      je AllocateRasEntryName1
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

.elseif eax == IDM_Hangup

mov l_RASCONN.dwSize, sizeof RASCONN + 1
mov l_Buffer_Size, sizeof l_RASCONN

; list all active RAS connections
invoke RasEnumConnections, addr l_RASCONN, addr l_Buffer_Size, addr l_Conn_Count

; terminate the Remote Access Connection

invoke RasHangUp, l_RASCONN.hrasconn

invoke Sleep,1500 ; give the system enuf time to end the connection
                  ; don't want to leave the port in an inconsistent state.

               .endif
            .endif 
                   
    .elseif uMsg == WM_SIZE
            
            ; Places app icon in the system tray.
            
            .if wParam == SIZE_MINIMIZED 
                mov note.cbSize,SIZEOF NOTIFYICONDATA 
                push hWin 
                pop note.hwnd 
                mov note.uID,IDI_TRAY 
                mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP 
                mov note.uCallbackMessage,WM_SHELLNOTIFY 
                mov eax,hIcon
                mov note.hIcon,eax 
                invoke lstrcpy,ADDR note.szTip,ADDR szDisplayName
                invoke ShowWindow,hWin,SW_HIDE 
                invoke Shell_NotifyIcon,NIM_ADD,ADDR note 
            .endif 

    .elseif uMsg == WM_SHELLNOTIFY 
            
            ; Pop up apps menu if the user right clicks on sys tray icon.
            
            .if wParam == IDI_TRAY
                .if lParam == WM_RBUTTONDOWN or WM_RBUTTONUP
                    invoke GetCursorPos,ADDR pt 
                    invoke SetForegroundWindow,hWin 
                    invoke TrackPopupMenuEx,hPopupMenu,
                                            TPM_RIGHTALIGN or TPM_LEFTBUTTON,
                                            pt.x,pt.y,hWin,0 
                    invoke PostMessage,hWin,WM_NULL,0,0
                .endif 
            .endif 

    .elseif uMsg == WM_DESTROY
            
            ; Destroy popup menu and shut down our app.
                     
            invoke DestroyMenu,hPopupMenu 
            invoke PostQuitMessage,0 

    .endif 

    invoke DefWindowProc,hWin,uMsg,wParam,lParam 
    ret 

WndProc endp

end start 
